$
$  TOPPERS/A-WDG
$      Automotive Watchdog Driver
$
$  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
$                             Graduate School of Information Science, Nagoya Univ., JAPAN
$  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
$  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
$  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
$  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
$  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
$  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
$  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
$  Copyright (C) 2014-2015 by Witz Corporation
$
$  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$  ܥեȥѤΤޤࡥʲƱˤѡʣ
$  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$      ˴ޤޤƤ뤳ȡ
$  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$      ѤǤǺۤˤϡۤȼɥȡ
$      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$      ̵ݾڵǺܤ뤳ȡ
$  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$      ѤǤʤǺۤˤϡΤ줫ξ
$      ȡ
$    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$        𤹤뤳ȡ
$  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$      դ뤳ȡ
$
$  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
$  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
$  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
$  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
$
$  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$  TOPPERSץȤϡܥեȥ˴ؤơλŪ
$  ФŬޤơʤݾڤԤʤޤܥեȥ
$  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$  Ǥʤ
$
$  $Id: wdg.tf 1553 2015-07-09 06:03:00Z suzuki-kawaguchi $
$

$ ====================================================================
$ booleanȽؿ
$ ====================================================================
$FUNCTION IS_TRUE$
	$true_list = {1, "1", "true", "TRUE", "ON", "ENABLE"}$
	$false_list = {0, "0", "false", "FALSE", "OFF", "DISABLE"}$
	$error_flag = 1$

	$FOREACH false false_list$
		$IF EQ(false, ARGV[1])$
			$check_result = VALUE("FALSE", 0)$
			$error_flag = 0$
		$END$
	$END$
	$FOREACH true true_list$
		$IF EQ(true, ARGV[1])$
			$check_result = VALUE("TRUE", 1)$
			$error_flag = 0$
		$END$
	$END$

	$IF error_flag > 0$
		$ERROR ARGV[2]$$FORMAT(_("%1% must be boolean type"), ARGV[1])$$END$
	$END$

	$RESULT = check_result$
$END$

$ ====================================================================
$ 껻ؿ
$ ====================================================================
$FUNCTION DIV$
$	// ˾ꤵƤʤϥ顼
	$tmp = REGEX_REPLACE(ARGV[1], "^[0-9]+\\.[0-9]+$", "")$
	$IF !EQ(tmp, "")$
		$ERROR$$FORMAT(_("%1% is not a float value."), ARGV[1])$$END$$DIE()$
	$END$
	$tmp = REGEX_REPLACE(ARGV[2], "^[0-9]+\\.[0-9]+$", "")$
	$IF !EQ(tmp, "")$
		$ERROR$$FORMAT(_("%1% is not a float value."), ARGV[2])$$END$$DIE()$
	$END$

	$num1_l = REGEX_REPLACE(ARGV[1], "^([0-9]+)\\.[0-9]+$", "$1")$
	$num1_r = REGEX_REPLACE(ARGV[1], "^[0-9]+\\.([0-9]+)$", "$1")$
	$num1_r = REGEX_REPLACE(CONCAT(num1_r, "0000"), "^(....).*$", "$1")$
	$num1 = ATOI(CONCAT(num1_l, num1_r), 10)$
	$num2_l = REGEX_REPLACE(ARGV[2], "^([0-9]+)\\.[0-9]+$", "$1")$
	$num2_r = REGEX_REPLACE(ARGV[2], "^[0-9]+\\.([0-9]+)$", "$1")$
	$num2_r = REGEX_REPLACE(CONCAT(num2_r, "0000"), "^(....).*$", "$1")$
	$num2 = ATOI(CONCAT(num2_l, num2_r), 10)$
	$div_result = num1 / num2$
	$mod_result = num1 % num2$

$	// 껻;Ϸ夲
	$IF mod_result > 0$
		$div_result = div_result + 1$
	$END$
	$RESULT = div_result$
$END$

$ ====================================================================
$ ɥץؿ
$ ====================================================================
$FUNCTION SET_WINDOW_PARAM$
	$window_open_rate_check = "FALSE"$
	$FOREACH window_open_rate TARGET_WINDOW_OPEN_LIST$
		$IF EQ(ARGV[1], window_open_rate)$
			$window_open_rate_check = "TRUE"$
		$END$
	$END$
	$IF EQ(window_open_rate_check, "FALSE")$
		$ERROR$$FORMAT(_("%1% is not valid in this target."), ARGV[1])$$END$$DIE()$
	$END$
$END$

$ ====================================================================
$ ॢȻؿ
$ ====================================================================
$FUNCTION SET_HW_TIMEOUT_PARAM$
	$hw_timeout = DIV(ARGV[1], "0.001")$
	$IF LENGTH(TARGET_HW_TIMEOUT_LIST)$ 
		$hw_timeout_check = "FALSE"$
		$FOREACH hw_timeout_list TARGET_HW_TIMEOUT_LIST$
			$IF EQ(hw_timeout, hw_timeout_list)$
				$hw_timeout_check = "TRUE"$
			$END$
		$END$
		$IF EQ(hw_timeout_check, "FALSE")$
			$ERROR$$FORMAT(_("%1% is not valid in this target."), ARGV[1])$$END$$DIE()$
		$END$
	$END$
	$RESULT = hw_timeout$
$END$

$ ====================================================================
$  顼åؿ
$ ====================================================================
$FUNCTION ERROR_CHECK$
	$is_boolean = IS_TRUE(WdgGeneral.WdgDevErrorDetect[1])$
	$disable_allow = IS_TRUE(WdgGeneral.WdgDisableAllowed[1])$
	$is_boolean = IS_TRUE(WdgGeneral.WdgVersionInfoApi[1])$

	$toggle_allow = IS_TRUE(TARGET_TOGGLE_ALLOW)$
	$window_allow = IS_TRUE(TARGET_WINDOW_ALLOW)$
	$trigger_location_allow = IS_TRUE(TARGET_TRIGGER_LOCATION_ALLOW)$
	$target_run_area_allow = IS_TRUE(TARGET_RUN_AREA_ALLOW)$
	$reset_allow = IS_TRUE(TARGET_TIMEOUT_RESET_ALLOW)$
	$nmi_allow = IS_TRUE(TARGET_TIMEOUT_NMI_ALLOW)$
	$mode_set_allow = IS_TRUE(TARGET_MODE_SET_ALLOW)$

$	//[WDG090][WDG092] ¸ͭݥå
$	//åɥå⡼å
	$IF EQ(WdgPublishedInformation.WdgTriggerMode[1], "WDG_BOTH")$
		$IF (EQ(toggle_allow, "FALSE") || EQ(window_allow, "FALSE"))$
			$ERROR$$FORMAT(_("WDG_BOTH is not valid in this target."))$$END$$DIE()$
		$ELSE$
			$FOREACH config_id WdgSettingsConfig.ID_LIST$
				$FOREACH fast_id WdgSettingsFast.ID_LIST$
					$IF EQ(config_id, WdgSettingsFast.PARENT[fast_id])$
$						//ɥץ
						$IF EQ(WdgSettingsFast.WdgTriggerMode[fast_id], "WDG_TOGGLE")$
$							//ȥ⡼ɤξ硤ɥץ֤100
							$WdgSettingsFast.WdgWindowOpenRate[fast_id] = 100$
						$ELIF EQ(WdgSettingsFast.WdgTriggerMode[fast_id], "WDG_WINDOW")$
$							//ɥ⡼ɤξ硤ɥץ֤ꥹȤˤ뤫ǧ
							$SET_WINDOW_PARAM(WdgSettingsFast.WdgWindowOpenRate[fast_id])$
						$ELSE$
							$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsFast.WdgTriggerMode[fast_id])$$END$$DIE()$
						$END$
$						//ॢȻ
						$WdgSettingsFast.WdgTimeout[fast_id] = SET_HW_TIMEOUT_PARAM(WdgSettingsFast.WdgTimeout[fast_id])$
					$END$
				$END$
				$FOREACH slow_id WdgSettingsSlow.ID_LIST$
					$IF EQ(config_id, WdgSettingsSlow.PARENT[slow_id])$
$						//ɥץ
						$IF EQ(WdgSettingsSlow.WdgTriggerMode[slow_id], "WDG_TOGGLE")$
$							//ȥ⡼ɤξ硤ɥץ֤100
							$WdgSettingsSlow.WdgWindowOpenRate[slow_id] = 100$
						$ELIF EQ(WdgSettingsSlow.WdgTriggerMode[slow_id], "WDG_WINDOW")$
$							//ɥ⡼ɤξ硤ɥץ֤ꥹȤˤ뤫ǧ
							$SET_WINDOW_PARAM(WdgSettingsSlow.WdgWindowOpenRate[slow_id])$
						$ELSE$
							$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsSlow.WdgTriggerMode[slow_id])$$END$$DIE()$
						$END$
$						//ॢȻ
						$WdgSettingsSlow.WdgTimeout[slow_id] = SET_HW_TIMEOUT_PARAM(WdgSettingsSlow.WdgTimeout[slow_id])$
					$END$
				$END$
			$END$
		$END$
	$ELIF EQ(WdgPublishedInformation.WdgTriggerMode[1], "WDG_TOGGLE")$
		$IF EQ(toggle_allow, "FALSE")$
			$ERROR$$FORMAT(_("WDG_TOGGLE is not valid in this target."))$$END$$DIE()$
		$ELSE$
			$FOREACH config_id WdgSettingsConfig.ID_LIST$
				$FOREACH fast_id WdgSettingsFast.ID_LIST$
					$IF EQ(config_id, WdgSettingsFast.PARENT[fast_id])$
$						//ȥ⡼ɤξ硤ɥץ֤100
						$IF !EQ(WdgSettingsFast.WdgTriggerMode[fast_id], "WDG_TOGGLE")$
							$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsFast.WdgTriggerMode[fast_id])$$END$$DIE()$
						$ELSE$
							$WdgSettingsFast.WdgWindowOpenRate[fast_id] = 100$
						$END$
$						//ॢȻ
						$WdgSettingsFast.WdgTimeout[fast_id] = SET_HW_TIMEOUT_PARAM(WdgSettingsFast.WdgTimeout[fast_id])$
					$END$
				$END$
				$FOREACH slow_id WdgSettingsSlow.ID_LIST$
					$IF EQ(config_id, WdgSettingsSlow.PARENT[slow_id])$
$						//ȥ⡼ɤξ硤ɥץ֤100
						$IF !EQ(WdgSettingsSlow.WdgTriggerMode[slow_id], "WDG_TOGGLE")$
							$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsSlow.WdgTriggerMode[slow_id])$$END$$DIE()$
						$ELSE$
							$WdgSettingsSlow.WdgWindowOpenRate[slow_id] = 100$
						$END$
$						//ॢȻ
						$WdgSettingsSlow.WdgTimeout[slow_id] = SET_HW_TIMEOUT_PARAM(WdgSettingsSlow.WdgTimeout[slow_id])$
					$END$
				$END$
			$END$
		$END$
	$ELIF EQ(WdgPublishedInformation.WdgTriggerMode[1], "WDG_WINDOW")$
		$IF EQ(window_allow, "FALSE")$
			$ERROR$$FORMAT(_("WDG_WINDOW is not valid in this target."))$$END$$DIE()$
		$ELSE$
			$FOREACH config_id WdgSettingsConfig.ID_LIST$
				$FOREACH fast_id WdgSettingsFast.ID_LIST$
					$IF EQ(config_id, WdgSettingsFast.PARENT[fast_id])$
						$IF !EQ(WdgSettingsFast.WdgTriggerMode[fast_id], "WDG_WINDOW")$
							$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsFast.WdgTriggerMode[fast_id])$$END$$DIE()$
						$ELSE$
$							//ɥ⡼ɤξ硤ɥץ֤ꥹȤˤ뤫ǧ
							$SET_WINDOW_PARAM(WdgSettingsFast.WdgWindowOpenRate[fast_id])$
$							//ॢȻ
							$WdgSettingsFast.WdgTimeout[fast_id] = SET_HW_TIMEOUT_PARAM(WdgSettingsFast.WdgTimeout[fast_id])$
						$END$
					$END$
				$END$
				$FOREACH slow_id WdgSettingsSlow.ID_LIST$
					$IF EQ(config_id, WdgSettingsSlow.PARENT[slow_id])$
						$IF !EQ(WdgSettingsSlow.WdgTriggerMode[slow_id], "WDG_WINDOW")$
							$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsSlow.WdgTriggerMode[slow_id])$$END$$DIE()$
						$ELSE$
$							//ɥ⡼ɤξ硤ɥץ֤ꥹȤˤ뤫ǧ
							$SET_WINDOW_PARAM(WdgSettingsSlow.WdgWindowOpenRate[slow_id])$
$							//ॢȻ
							$WdgSettingsSlow.WdgTimeout[slow_id] = SET_HW_TIMEOUT_PARAM(WdgSettingsSlow.WdgTimeout[slow_id])$
						$END$
					$END$
				$END$
			$END$
		$END$
	$ELSE$
		$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgPublishedInformation.WdgTriggerMode[1])$$END$$DIE()$
	$END$

$	//󥨥ꥢå
	$IF EQ(target_run_area_allow, "FALSE")$
		$WARNING$$FORMAT(_("WdgRunArea is not valid in this target."))$$END$
	$ELSE$
		$IF (!EQ(WdgGeneral.WdgRunArea[1], "ROM") && !EQ(WdgGeneral.WdgRunArea[1], "RAM"))$
			$ERROR$$FORMAT(_("%1% must be ROM or RAM."), WdgGeneral.WdgRunArea[1])$$END$$DIE()$
		$END$
	$END$

$	//ȥꥬå
	$IF EQ(trigger_location_allow, "FALSE")$
		$WARNING$$FORMAT(_("WdgTriggerLocation is not valid in this target."))$$END$
	$END$

$	//ꥻå or NMIå
	$FOREACH config_id WdgSettingsConfig.ID_LIST$
		$FOREACH fast_id WdgSettingsFast.ID_LIST$
			$IF EQ(config_id, WdgSettingsFast.PARENT[fast_id])$
				$IF EQ(WdgSettingsFast.WdgTimeoutReaction[fast_id], "WDG_NMI")$
					$IF EQ(nmi_allow, "FALSE")$
						$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsFast.WdgTimeoutReaction[fast_id])$$END$$DIE()$
					$END$
				$ELIF EQ(WdgSettingsFast.WdgTimeoutReaction[fast_id], "WDG_RESET")$
					$IF EQ(reset_allow, "FALSE")$
						$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsFast.WdgTimeoutReaction[fast_id])$$END$$DIE()$
					$END$
				$ELSE$
					$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsFast.WdgTimeoutReaction[fast_id])$$END$$DIE()$
				$END$
			$END$
		$END$
		$FOREACH slow_id WdgSettingsSlow.ID_LIST$
			$IF EQ(config_id, WdgSettingsSlow.PARENT[slow_id])$
				$IF EQ(WdgSettingsSlow.WdgTimeoutReaction[slow_id], "WDG_NMI")$
					$IF EQ(nmi_allow, "FALSE")$
						$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsSlow.WdgTimeoutReaction[slow_id])$$END$$DIE()$
					$END$
				$ELIF EQ(WdgSettingsSlow.WdgTimeoutReaction[slow_id], "WDG_RESET")$
					$IF EQ(reset_allow, "FALSE")$
						$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsSlow.WdgTimeoutReaction[slow_id])$$END$$DIE()$
					$END$
				$ELSE$
					$ERROR$$FORMAT(_("%1% is not valid in this target."), WdgSettingsSlow.WdgTimeoutReaction[slow_id])$$END$$DIE()$
				$END$
			$END$
		$END$
	$END$

$	//[WDG173] ϰϥå
	$init_num = DIV(WdgGeneral.WdgInitialTimeout[1], "0.001")$
	$max_num = DIV(WdgGeneral.WdgMaxTimeout[1], "0.001")$
	$IF init_num > max_num$
		$ERROR$$FORMAT(_("WdgInitialTimeout must be not larger than WdgMaxTimeout."))$$END$$DIE()$
	$END$

	$IF (init_num < 0) || (init_num > 65535)$
		$ERROR$$FORMAT(_("WdgInitialTimeout is illegal range."))$$END$$DIE()$
	$END$

	$IF (max_num < 0) || (max_num > 65535)$
		$ERROR$$FORMAT(_("WdgMaxTimeout is illegal range."))$$END$$DIE()$
	$END$

	$FOREACH config_id WdgSettingsConfig.ID_LIST$
$	//[WDG025] åɥå̵ԵĤǥǥեȥ⡼ɤOFF_MODEξ硤顼
		$IF (EQ(WdgSettingsConfig.WdgDefaultMode[config_id], "WDGIF_OFF_MODE") && EQ(disable_allow, "FALSE"))$
			$ERROR$$FORMAT(_("Disabling the watchdog driver at runtime is not allowed. (DEM_ERROR WDG_E_DISABLE_REJECTED)"))$$END$$DIE()$
		$ELIF (!EQ(WdgSettingsConfig.WdgDefaultMode[config_id], "WDGIF_OFF_MODE") && !EQ(WdgSettingsConfig.WdgDefaultMode[config_id], "WDGIF_FAST_MODE") && !EQ(WdgSettingsConfig.WdgDefaultMode[config_id], "WDGIF_SLOW_MODE"))$
			$ERROR$$FORMAT(_("WdgDefaultMode is illegal value."))$$END$$DIE()$
		$END$

$	//⡼ڤؤ̵б
		$IF EQ(mode_set_allow, "TRUE")$
			$mode_container_num = 2$
			$slow_confirmation = "FALSE"$
			$FOREACH slow_id WdgSettingsSlow.ID_LIST$
				$IF EQ(config_id, WdgSettingsSlow.PARENT[slow_id])$
					$slow_confirmation = "TRUE"$
				$END$
			$END$
			$IF EQ(slow_confirmation, "FALSE")$
				$ERROR$$FORMAT(_("WdgSlowMode setting is necessary."))$$END$$DIE()$
			$END$
		$ELSE$
			$mode_container_num = 1$
$			//ǥեȥ⡼
			$IF !EQ(WdgSettingsConfig.WdgDefaultMode[config_id], "WDGIF_FAST_MODE")$
				$WdgSettingsConfig.WdgDefaultMode[config_id] = "WDGIF_FAST_MODE"$
				$WARNING$$FORMAT(_("This target can be set only WDGIF_FAST_MODE. DefaultMode set to WDGIF_FAST_MODE"))$$END$
			$END$
			$slow_confirmation = "FALSE"$
			$FOREACH slow_id WdgSettingsSlow.ID_LIST$
				$IF EQ(config_id, WdgSettingsSlow.PARENT[slow_id])$
					$slow_confirmation = "TRUE"$
				$END$
			$END$
			$IF EQ(slow_confirmation, "TRUE")$
				$WARNING$$FORMAT(_("WdgSlowMode setting is ignored."))$$END$$DIE()$
			$END$
		$END$
	$END$



$END$

$ ====================================================================
$  ץ쥳ѥѥإåؿ
$ ====================================================================
$FUNCTION GEN_WDG_CFG_H$
	$FILE "Wdg_Cfg.h"$
	/* Wdg_Cfg.h */$NL$

	#ifndef TOPPERS_A_WDG_CFG_H$NL$
	#define TOPPERS_A_WDG_CFG_H$NL$
	$NL$
$	// [WDG073_Conf] Wdg
$	// WdgDemEventParameterRefs 
$	// [WDG150_Conf] WDG_E_DISABLE_REJECTED
	#define WDG_DEM_DISABLE_REJECTED$TAB$
	$IF LENGTH(WdgDemEventParameterRefs.WDG_E_DISABLE_REJECTED[1])$
		$DemEventParameter.DemEventId[WdgDemEventParameterRefs.WDG_E_DISABLE_REJECTED[1]]$U
	$ELSE$
		WDG_INVALID_UINT16	/* [NWDG003] ̵ */
	$END$
	$NL$
$	// [WDG149_Conf] WDG_E_MODE_FAILED
	#define WDG_DEM_MODE_FAILED$TAB$$TAB$$TAB$
$	// [WDG148_Conf] WdgDemEventParameterRefs
	$IF LENGTH(WdgDemEventParameterRefs.WDG_E_MODE_FAILED[1])$
		$DemEventParameter.DemEventId[WdgDemEventParameterRefs.WDG_E_MODE_FAILED[1]]$U
	$ELSE$
		WDG_INVALID_UINT16	/* [NWDG003] ̵ */
	$END$
	$NL$
$	// [WDG156]
$	// [WDG114_Conf] WdgGeneral 
$	// [WDG115_Conf] WdgDevErrorDetect
	#define WDG_DEV_ERROR_DETECT$TAB$$TAB$$IS_TRUE(WdgGeneral.WdgDevErrorDetect[1])$$NL$
$	// [WDG116_Conf] WdgDisableAllowed
	#define WDG_DISABLE_ALLOWED$TAB$$TAB$$TAB$$IS_TRUE(WdgGeneral.WdgDisableAllowed[1])$$NL$
$	// [WDG117_Conf] WdgIndex
$	// [WDG130_Conf] WdgInitialTimeout
$	// äߥäѴ롥ݤؿʤᡤDIVؿѤƤ
	$num1 = DIV(WdgGeneral.WdgInitialTimeout[1], "0.001")$
	#define WDG_INIT_TIMEOUT$TAB$$TAB$$TAB$$num1$U$NL$
$	// [WDG131_Conf] WdgMaxTimeout
	$num2 = DIV(WdgGeneral.WdgMaxTimeout[1], "0.001")$
	#define WDG_MAX_TIMEOUT$TAB$$TAB$$TAB$$TAB$$num2$U$NL$
$	// [WDG147_Conf] WdgRunArea
$	// [WDG118_Conf] WdgTriggerLocation
$	// [WDG119_Conf] WdgVersionInfoApi
	#define WDG_VERSION_INFO_API$TAB$$TAB$$IS_TRUE(WdgGeneral.WdgDisableAllowed[1])$$NL$
$	// ⡼ڤؤȽ
	#define WDG_SET_MODE_VALID$TAB$$TAB$$TAB$$mode_set_allow$$NL$
	$NL$
	#endif /* TOPPERS_A_WDG_CFG_H */
$	// [WDG074_Conf] WdgPublishedInformation
$	// [WDG127_Conf] WdgTriggerMode

$END$

$ ====================================================================
$  [WDG079] ݥȥӥѥإåؿ
$ ====================================================================
$FUNCTION GEN_WDG_PB_CFG_H$
	$FILE "Wdg_PBcfg.h"$

	/* Wdg_PBcfg.h */$NL$

	#ifndef TOPPERS_A_WDG_PB_CFG_H$NL$
	#define TOPPERS_A_WDG_PB_CFG_H$NL$
	$NL$

	$FOREACH config_id WdgSettingsConfig.ID_LIST$
		extern const Wdg_ConfigType wdg_config_$config_id$;$NL$
	$END$
	$NL$
	#endif /* TOPPERS_A_WDG_PB_CFG_H */
$END$

$ ====================================================================
$  ݥȥӥѼؿ
$ ====================================================================
$FUNCTION GEN_WDG_PB_CFG_C$
	$FILE "Wdg_PBcfg.c"$

	/* Wdg_PBcfg.c */$NL$
	$NL$

	#include "Os.h"$NL$
	#include "Wdg.h"$NL$
	#include "Wdg_PBcfg.h"$NL$
	#include "MemMap.h"$NL$
	$NL$

	/* ȥꥬ֥å : wdg_config_<WdgSettingConfig>_trigger */$NL$
	$FOREACH config_id WdgSettingsConfig.ID_LIST$
		static TRIGGER_CB wdg_config_$config_id$_trigger;$NL$
	$END$
	$NL$

$	// [WDG082_Conf][NWDG001] WdgSettingsConfig
	$FOREACH config_id WdgSettingsConfig.ID_LIST$
$		// [WDG121_Conf] WdgSettingsFast
		$FOREACH fast_id WdgSettingsFast.ID_LIST$
			$IF EQ(config_id, WdgSettingsFast.PARENT[fast_id])$
				/* WdgFast⡼ɽ֥å : wdg_config_<WdgSettingConfig>_fast_mode_inib */$NL$
				static const WDG_MODE_INIB wdg_config_$config_id$_fast_mode_inib = {$NL$
					$TAB$$WdgSettingsFast.WdgTimeoutReaction[fast_id]$, /* [NWDG002] WdgTimeoutReaction */$NL$
					$TAB$$WdgSettingsFast.WdgWindowOpenRate[fast_id]$U, /* [NWDG002] WdgWindowOpenRate */$NL$
					$TAB$$WdgSettingsFast.WdgTimeout[fast_id]$U, /* [NWDG002] timeout */$NL$
					$num1 = DIV(WdgSettingsFast.WdgTriggerInterruptPeriod[fast_id], "0.001")$
					$TAB$$num1$U /* [NWDG002] interrupt_period */$NL$
				};$NL$
				$NL$
			$END$
		$END$
$		// [WDG123_Conf][NWDG008] WdgSettingsSlow
		$IF EQ(mode_set_allow, "TRUE")$
			$FOREACH slow_id WdgSettingsSlow.ID_LIST$
				$IF EQ(config_id, WdgSettingsSlow.PARENT[slow_id])$
					/* WdgSlow⡼ɽ֥å : wdg_config_<WdgSettingConfig>_slow_mode_inib */$NL$
					static const WDG_MODE_INIB wdg_config_$config_id$_slow_mode_inib = {$NL$
						$TAB$$WdgSettingsSlow.WdgTimeoutReaction[slow_id]$, /* [NWDG002] WdgTimeoutReaction */$NL$
						$TAB$$WdgSettingsSlow.WdgWindowOpenRate[slow_id]$U, /* [NWDG002] WdgWindowOpenRate */$NL$
						$TAB$$WdgSettingsSlow.WdgTimeout[slow_id]$U, /* [NWDG002] timeout */$NL$
						$num1 = DIV(WdgSettingsSlow.WdgTriggerInterruptPeriod[slow_id], "0.001")$
						$TAB$$num1$U /* [NWDG002] interrupt_period */$NL$
					};$NL$
					$NL$
				$END$
			$END$
		$END$		
	$END$
	
$	// [WDG082_Conf][NWDG001] WdgSettingsConfig
	$FOREACH config_id WdgSettingsConfig.ID_LIST$
		/* Wdgե졼 : wdg_config_<WdgSettingConfig> */$NL$
		const Wdg_ConfigType wdg_config_$config_id$ = {$NL$
$		// [WDG120_Conf][NWDG008] WdgDefaultMode
		$TAB$$WdgSettingsConfig.WdgDefaultMode[config_id]$, /* WdgDefaultMode */$NL$
		$TAB$&wdg_config_$config_id$_fast_mode_inib, /* p_fast_mode_inib */$NL$
		$IF EQ(mode_set_allow, "TRUE")$
			$TAB$&wdg_config_$config_id$_slow_mode_inib, /* p_slow_mode_inib */$NL$
		$ELSE$
			$TAB$NULL_PTR, /* p_slow_mode_inib */$NL$
		$END$
		$TAB$&wdg_config_$config_id$_trigger /* p_trigger_cb */$NL$
		};$NL$
	$END$
$END$

$ ====================================================================
$  ᥤ
$ ====================================================================

$ [WDG086] 顼å
$ERROR_CHECK()$

$ [WDG157] ץ쥳ѥ
$GEN_WDG_CFG_H()$

$ [WDG079][WDG159] ݥȥӥѥץ
$GEN_WDG_PB_CFG_H()$
$GEN_WDG_PB_CFG_C()$

$ DUMP()$

$	̤ݡȻͥ
$	- DIO
$	  <WDG112_Conf><WDG113_Conf>

